<template>
    <div>
        <crumbs title="医学术语命名维护" minWidth="995px" class="knowledgeTitle">
            <el-form :inline="true" class="demo-form-inline">
              <el-form-item>
                <el-button size="mini" :type="reloadFlag?'danger':'info'"  @click="reloadLib" style="margin:0 10px">加载词库</el-button>
              </el-form-item>
              <el-form-item label="医学标准术语：">
                  <el-input size="mini" v-model="filter.term" placeholder="输入术语"></el-input>
              </el-form-item>
              <el-form-item label="术语类型：">
                <el-select v-model="filter.type"
                clearable 
                filterable 
                placeholder="请选择" 
                size="mini">
                  <el-option
                    v-for="item in typeList"
                    :key="item.id"
                    :label="item.name"
                    :value="item.name">
                  </el-option>
                </el-select>
              </el-form-item>
              <el-form-item label="同义词：">
                  <el-input size="mini" v-model="filter.libName" placeholder="输入同义词"></el-input>
              </el-form-item>
              <el-form-item label="状态：">
                <el-select v-model="filter.isState" clearable placeholder="请选择" size="mini">
                  <el-option
                    v-for="item in stateSelect"
                    :key="item.id"
                    :label="item.name"
                    :value="item.id">
                  </el-option>
                </el-select>
              </el-form-item>
                <el-form-item>
                  <el-button size="mini" @click="filterDatas">确认</el-button>
                </el-form-item>
            </el-form>
            <el-form class="secLine">
              <el-form-item>
                  <el-button size="mini" @click="uploadClick">导入</el-button>
                  <input type="file" name="uploadfile " id="upFile" @change="uploadFile($event)" accept=".csv, application/vnd.ms-excel, application/vnd.openxmlformats-officedocument.spreadsheetml.sheet">
                  <!-- <router-link to="/admin/LT-YXSYKWH-TJYXSY" style="margin:0 10px">
                      <el-button size="mini" type="warning">添加医学标准术语</el-button>
                  </router-link> -->
                  <el-button size="mini" type="warning"  @click="addMedicalName" style="margin:0 10px">添加医学标准术语</el-button>
              </el-form-item>
            </el-form>
        </crumbs>
        <div class="contents knowledgeContents">
            <el-table :data="list"
                      border
                      style="width: 100%">
                <el-table-column
                        type="index"
                        :index="indexMethod"
                        label="编号"
                        width="60">
                </el-table-column>
                <el-table-column
                        prop="operTime"
                        label="操作时间"
                        :show-overflow-tooltip="true">
                </el-table-column>
                <el-table-column
                        prop="libName"
                        label="医学标准术语"
                        show-overflow-tooltip>
                </el-table-column>
                <el-table-column
                        prop="libType"
                        label="术语类型">
                </el-table-column>
                <el-table-column
                        prop="otherNames"
                        label="同义词"
                        show-overflow-tooltip>
                </el-table-column>
                <el-table-column
                        label="状态">
                        <template slot-scope="scope">
                          <span :class="scope.row.isDeleted == 'N'?'':'delete'">
                            {{scope.row.isDeleted == 'N'?'启用中':'已删除'}}
                          </span>
                        </template>
                </el-table-column>
                <el-table-column
                        prop="operName"
                        label="操作人">
                </el-table-column>
                
                <el-table-column
                        label="操作" width="160">
                    <template slot-scope="scope">
                        <el-button type="text" size="small" :disabled="scope.row.isDeleted != 'N'" @click="toEditProduct(scope.row)">修改</el-button>
                        <span style="margin:0 3px;">|</span>
                        <el-button type="text" size="small" :disabled="scope.row.isDeleted != 'N'" @click="toEditProduct(scope.row,true)">复制</el-button>
                        <span style="margin:0 3px;">|</span>
                        <el-button type="text" size="small" :class="scope.row.isDeleted == 'N'?'delete':'review'" @click="showDelDialog(scope.row)">{{scope.row.isDeleted == 'N'?'删除':'恢复'}}</el-button>
                    </template>
                </el-table-column>
            </el-table>
            <el-pagination v-if="total>pageSize"
                           :current-page.sync="currentPage"
                           @current-change="currentChange"
                           background
                           :page-size="pageSize"
                           layout="total,prev, pager, next, jumper"
                           :total="total">
            </el-pagination>
        </div>

    </div>
</template>

<script>
  import api from '@api/icss.js';

  export default {
    name: 'MedicalName',
    data: function () {
      return {
        list: [],
        stateSelect:[
          {id:'N',name:'启用中'},
          {id:'Y',name:'已删除'},
        ],
        // isState:'',
        cacheData: {}, //因为删除和恢复要及时更新，所以不做缓存
        currentPage: 1,
        pageSize: 10,
        total: 0,
        searched:false,
        filter: {
          term:'',
          type:'',
          libName:'',
          isState:'',
        },
        typeList:[],
        reloadFlag:true
      }
    },
    created() {
      // this.getDataList();
      this.getTypeList();
      const that = this;
      //返回时避免参数未赋值就获取列表
      setTimeout(function(){
        that.getDataList();
      });
    },
    watch:{
      'filter':{
        handler:function(){
          this.searched = false;
        },
        deep:true
      }
    },
    beforeRouteEnter(to, from, next){
      next(vm => {
        //const pm = to.param;
        Object.assign(vm,to.params);
      })
    },
    methods: {
      reloadLib(){
        if(this.reloadFlag){
          this.reloadFlag = false;
          api.reloadLib().then((res)=>{
            if (res.data.code == 0) {
              this.reloadFlag = true;
            }
          })
        }  
      },
      addMedicalName(){
        const pam = this.searched?{currentPage:this.currentPage,
          filter:this.filter}:{currentPage:this.currentPage};
        this.$router.push({name:'AddMedicalName',
          params:pam});
      },
      toEditProduct(row,copy){
        const pam = this.searched?{currentPage:this.currentPage,
          filter:this.filter}:{currentPage:this.currentPage};
        this.$router.push({
          name:'AddMedicalName',
          // params: {info:row}
          params: Object.assign(pam,{id:row.conceptId,copy:copy})
        })
      },
      filterDatas(){
        this.currentPage = 1;
        this.getDataList();
      },
      getDataList(isTurnPage) {
        const param = this.getFilterItems(isTurnPage);
        this.searched = true;
        api.knowledgeName(param).then((res) => {
          if (res.data.code == '0') {
            const data = res.data.data;
            this.list = data.records;
            // this.cacheData[param.current] = data.records;
            this.total = data.total;
          }
        }).catch((error) => {
          console.log(error);
        });
      },
      getTypeList(){
        api.allKnowledgeType({'name':''}).then((res)=>{
          const data = res.data;
          if(data.code==0){
            this.typeList = data.data;
          }else{
            console.log(res.msg);
          }
        }).catch((error) => {
          console.log(error);
        });
      },
      /*getDetailList(id) {
        this.$router.push({name:'DeptInfoDetail', params:{id: id}})
      },*/
      getFilterItems(isTurnPage) {
        //翻页时筛选条件没点确定则清空
        if(isTurnPage&&!this.searched){
          this.clearFilter();
        };
        const param = {
          name: this.filter.term,
          current: this.currentPage,
          size: this.pageSize,
          type:this.filter.type,
          libName:this.filter.libName,
          isDeleted:this.filter.isState
        };
        return param;
      },
      indexMethod(index) {
        return ((this.currentPage - 1) * this.pageSize) + index + 1;
      },
      currentChange(next) {
        this.currentPage = next;
        // if (this.cacheData[next]) {       //如果已请求过该页数据，则使用缓存不重复请求
        //   this.list = this.cacheData[next];
        // } else {
          this.getDataList(true);
        // }
      },
      warning(msg,type){
        this.$message({
          showClose: true,
          message:msg,
          type:type||'warning'
        })
      },
      showConfirmDialog(msg,resolve){
        this.$alert(msg, '提示', {
          confirmButtonText: '确定',
          type: 'warning'
        }).then(() => {
          resolve();
        }).catch(() => {});
      },
      showDelDialog(item){
        /*const param = {
          term:item.term,
          type:item.type,
          id:item.id
        }*/
        const param = {
          conceptId:item.conceptId,
          isDeleted:item.isDeleted === 'N'?'Y':'N'
        }
        let waringTxt = (item.isDeleted === 'N'?'是否删除该标准术语？':'是否重新启用该条数据？')
        this.showConfirmDialog(waringTxt,()=>{
          api.deletMedicalName(param).then((res)=>{
            if(res.data.code=='0') {
              if (!this.searched) {
                //未点确认时清空搜索条件
                this.clearFilter();
              }
              if (item.isDeleted !== 'N') {       //恢复成功后跳转到筛选条件的首页
                this.currentPage = 1;
              } else {
                if (this.filter.isState!==''&&this.list.length === 1){
                  //有启用状态筛选条件且当前页只有最后一条数据删除时，删除成功后跳转到前一页
                  this.currentPage = this.currentPage===1?1:this.currentPage-1;
                  }
                }
              this.warning(res.data.msg||'操作成功','success');
              this.getDataList();
            }else{
              this.warning(res.data.msg);
            }
          }).catch((error)=>{
            this.warning(error);
          })
        });
      },
      clearFilter(){
        this.filter = {
          term:'',
          type:'',
          libName:'',
          isState:'',
        };
      },
      uploadClick(){
        let inp = document.getElementById("upFile");
        inp.click();
      },
      uploadFile(e){
        let fileInfo = e.target.files[0];
        e.preventDefault();
        let formData = new FormData();
        formData.append('uploadfile', fileInfo);
        const header = {
          headers:{
            'Content-Type': 'multipart/form-data'
          }
        }
        api.knowledgeUpload(formData,header).then((res)=>{
          if(res.data.code==0){
            this.$message({
              message: '上传成功',
              type: 'success',
            });
            this.getDataList();
          }else{
            /*this.$message({
              dangerouslyUseHTMLString: true,
              message:res.data.msg,
              type:'warning'
            });*/
            this.$alert(res.data.msg,'错误信息',{
              dangerouslyUseHTMLString: true,
              confirmButtonText: '确定',
              callback: action => {
                /*this.$message({
                  type: 'info',
                  message: `action: ${ action }`
                });*/
              }
            });
          }
        })
        
        //解决上传相同文件不触发change
        let inp = document.getElementById("upFile");
        inp.value = "";   
      },
    }
  }
</script>

<style lang="less" scoped>
    @import "../../less/admin.less";
    /deep/ .container.knowledgeTitle {
      height: 80px;
    }
    /deep/ .contents.knowledgeContents {
      padding: 104px 20px 0;
    }
    /deep/ .secLine.el-form {
      float: right;
      display: block;
      position: relative;
      top: -5px;
    }
    .delete{
        color: red;
    }
    .review{
      color: #22ccc8;
    }
    .el-table .cell{
      overflow: hidden;
      white-space: nowrap;
    }
    #upFile{
      display: none !important;
    }
</style>